/* Copyright (C) 1989 Aladdin Enterprises.  All rights reserved.
   Distributed by Free Software Foundation, Inc.

This file is part of Ghostscript.

Ghostscript is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility
to anyone for the consequences of using it or for whether it serves any
particular purpose or works at all, unless he says so in writing.  Refer
to the Ghostscript General Public License for full details.

Everyone is granted permission to copy, modify and redistribute
Ghostscript, but only under the conditions described in the Ghostscript
General Public License.  A copy of this license is supposed to have been
given to you along with Ghostscript so you can know your rights and
responsibilities.  It should be in a file named COPYING.  Among other
things, the copyright notice and this notice must be preserved on all
copies.  */

/* xlib.c */
/* Try out the X library */
#include <math.h>
#include "std.h"
#include "gxdevice.h"

char gs_debug[128];

extern gx_device x_device;

main()
{	main1();
}
main0()
{	long clock();
	long t1, t2, t3;
	int i;
	float f = 1.0;
	float sintab[24];
	for ( i = 0; i < 24; i++ )
	  sintab[i] = sin(i * 15 * (M_PI / 180));
#define N 1000
#define D 24
#define M 15
	t1 = clock();
	for ( i = 0; i < N; i++ )
	  { f = i % D * M;
	    f = sin(f);
	  }
	t2 = clock();
	for ( i = 0; i < N; i++ )
	  { int j, k;
	    f = i % D * M;
	    if ( f == (j = (int)f) && j >= 0 && j < 360 && j == (k = j / 15) * 15 )
	      f = sintab[k];
	    else
	      f = sin(f);
	  }
	t3 = clock();
	printf("calc=%ld lookup each %d=%ld\n", t2 - t1, M, t3 - t2);
}
main1()
{	unsigned short max_value = x_device.max_rgb_value;
	int colors[8];
	int i;
	static byte bits[] = {
		0x33,0x33,0,0,
		0x66,0x66,0,0,
		0xcc,0xcc,0,0,
		0x99,0x99,0,0
	};
	for ( i = 0; i < 8; i++ )
	  { colors[i] =
	      x_map_rgb_color(&x_device,
			      ((i & 4) >> 2) * max_value,
			      ((i & 2) >> 1) * max_value,
			      (i & 1) * max_value);
	    x_fill_rectangle(&x_device, i*64, 0, 64, 64, colors[i]);
	  }
	x_copy_mono(&x_device, bits, 0, 4, 32, 32, 32, 4, 0, 1);
	x_sync(&x_device);
	getchar();
}

/* Stubs */
int gx_default_tile_rectangle() {}
int gx_default_tile_trapezoid() {}
